#lang racket

;; ------------------------------------------------------------------------
;;  (read) reads an object, parses it, and returns it as a typed value.
;; ------------------------------------------------------------------------

(let ((v (read)))
  (number? v))

;; ------------------------------------------------------------------------
;; Low-level I/O in Racket, inherited from Scheme -- standard input stream
;; ------------------------------------------------------------------------

(read)   ; anything
(read)   ; foo bar baz
(read)
(read)

;; ------------------------------------------------------------------------
;; Low-level I/O in Racket -- port connected to a file
;; ------------------------------------------------------------------------

(open-input-file "racket-snippet.rkt")
(define in (open-input-file "racket-snippet.rkt"))
(read in)
(read in)
(close-input-port in)

(define in2 (open-input-file "datafile.txt"))
(define out (open-output-file "datafile-out.txt"))
(write "Echoing next three expressions to file" out)
(write (read in2) out)
(write (read in2) out)
(write (read in2) out)

(close-output-port out)
(close-input-port in2)

;; ------------------------------------------------------------------------
